// Copyright (c) 2012, the Dart project authors.  Please see the AUTHORS file
// for details. All rights reserved. Use of this source code is governed by a
// BSD-style license that can be found in the LICENSE file.

import "package:expect/expect.dart";
import "package:async_helper/async_helper.dart";
import '../compiler_helper.dart';

main() {
  runTest({bool useKernel}) async {
    String code = await compileAll(r'''main() { return "foo" + "bar"; }''',
        compileMode: useKernel ? CompileMode.kernel : CompileMode.memory);
    Expect.isTrue(!code.contains(r'$add'));
  }

  asyncTest(() async {
    print('--test from ast---------------------------------------------------');
    await runTest(useKernel: false);
    print('--test from kernel------------------------------------------------');
    await runTest(useKernel: true);
  });
}
